module Command

  def wear( client )

    player = client.player
    mesg   = player.mesg

    choice = client.select( mesg[ 1360 ], player.list_wearable,
			   mesg[ 152 .. 154 ], mesg [ 1361 ] )

    return if choice == ?\e 
    
    if !( object = player.pocket( choice ) ) || !object.wearable?
      message( client, mesg[ 1362 ] )
    elsif object.armor?
      wear_armor( client, object )
    elsif object.shield?
      wear_shield( client, object )
    end

  end

  def wear_armor( client, object )

    player = client.player
    mesg   = player.mesg

    if player.wear # ˳ѡ
      message( client, mesg[ 1363 ] )
    else
      player.wear_armor( object )
      item( client, object )
    end

  end
  
  def wear_shield( client, object )

    player = client.player
    mesg   = player.mesg

    if player.shield # ˽ѡ
      message( client, mesg[ 1364 ] )
    elsif ( weapon = player.wield ) && weapon.twohanded?
      message( client, mesg[ 1365 ] )
    else
      player.wear_shield( object )
      item( client, object )
    end
    
  end

  def wield( client )

    player = client.player
    mesg   = player.mesg

    choice = client.select( mesg[ 1370 ], player.list_wieldable,
			   mesg[ 152 .. 154 ], mesg [ 1371 ] )

    return if ( choice == ?\e )

    if !( object = player.pocket( choice ) )
      message( client, mesg[ 1372 ], choice )
    elsif !( object.wieldable? ) 
      message( client, mesg[ 1373 ], choice )
    elsif object.twohanded? && player.shield # ξȿ
      message( client, mesg[ 1374 ] )
    else
      player.wield_weapon( object )
      item( client, object )
    end

  end

  def stay_here( client ) ; return true ; end

  def drop( client, point )

    player = client.player
    mesg   = player.mesg
    
    return if player.timestop?

    choice = client.select( mesg[ 1380 ], player.all_item,
			   mesg[ 152 .. 154 ], mesg [ 1381 ] )

    return if choice == ?\e # 󥻥˥ȡ

    case choice
    when ?., ?G
      drop_gold( client, point )   # ⡣
    when ( ?a .. ?z )
      drop_object( client, point, choice ) # ƥࡣ
    end

  end

  def client_drop_get_amount( client, mesg )
    client.drop_get_amount( mesg )
  end

  
  def drop_gold( client, point )

    player = client.player
    mesg   = player.mesg
    
    if @cavelevel.point2object( point ) # Ǥ˥ƥब֤Ƥ..
      message( client, mesg[ 1382 ] )
      return
    end

    amount = client_drop_get_amount( client, mesg[ 1383 ] )

    if amount == 0

    elsif amount > player.gold # ۤ¿
      message( client, mesg[ 1384 ] )
    else
      player.lose_gold( amount )
      get_object( client, Larnobject.dropgold( amount ), point )
      message( client, mesg[ 1385 ], amount )
    end
    
  end

  def drop_object( client, point, alphabet )

    player = client.player
    mesg   = player.mesg

    if @cavelevel.point2object( point ) # Ǥ˥ƥब֤Ƥ..
      message( client, mesg[ 1387 ] )
      return
    end
    
    if !( object = player.pocket( alphabet ) )
      message( client, mesg[ 1386 ], alphabet )
    else
      do_drop( client, object, point )
    end
    
  end

  def do_drop( client, object, point )
    
    player = client.player

    message( client, player.mesg[ 1388 ] )
    item( client, object )
    player.lose_item( object )
    get_object( client, object, point )

  end

  def identify_trap( client, point )

    player = client.player
    mesg   = player.mesg

    found = false

    unless player.blindcount?

      @cavelevel.traps_near_with_point( point ).each do | opoint, obj |
	next unless player2screen( player ).know_object?( opoint, obj )
	found = true
	message( client, mesg[ 1390 ], player.objectname( obj ) )
      
      end
      
    end

    # 櫤ʤäޤĤƤʤȤˤ...
    message( client, mesg[ 1391 ] ) unless found

  end
  
  def pack_weight( client )
    player = client.player
    message( client, player.mesg[ 1400 ], player.packweight )
  end

  def take_off( client )

    player = client.player
    mesg   = player.mesg

    if player.shield
      message( client, mesg[ 1405 ] )
    elsif player.wear
      message( client, mesg[ 1406 ] )
    else
      message( client, mesg[ 1407 ] )
    end

    player.take_off

  end

  def tax_status( client )
    player = client.player
    message( client, player.mesg[ ( ( player.tax > 0 )? 1410 : 1411 ) ],
	    player.tax )
  end

  def all_item_found( client )

    player = client.player
    mesg   = player.mesg

    client.all_item_found( mesg[ 743 ], player.spell_list,  # ˡ
			  mesg[ 1415 ], player.scroll_list, # ʪ
			  mesg[ 1416 ], player.potion_list, # 
			  mesg[ 152 .. 154 ] ) # press space

  end

  def help( client )

    mesg = client.player.mesg
    
    client_help( client,
		mesg[ 1590 .. 1612 ], # ޥ
		mesg[ 1620 .. 1642 ], # Special Note
		mesg[ 1650 .. 1672 ], # Larnѡ
		mesg[ 1680 .. 1702 ], # larnoptե롣
		mesg[ 1710 .. 1732 ], # ܡɡ
		mesg[ 1740 .. 1744 ], # press return
		mesg[ 1745 .. 1747 ]  # press return
		)

  end

  # ͥåȥбˤ뤫⤷ʤΤ(???)
  # Ƥޤ
  
  def client_help( client, first, second, third, fourth, fifth,
		  press_space, press_enter )
    
    client.help( first, second, third, fourth, fifth,
		press_space, press_enter )
    
  end
  
  def command_go_up( client, point )

    player = client.player
   
    return false unless ( object = @cavelevel.point2object( point ) )

    # ­˳ʤȤRogueޥɡ
    if ( object.stairsup? )
      do_go_up( client, point )
    elsif object.store?
      ostore( client, object, point )
    end

  end

  def command_go_down( client, point )

    player = client.player

    return false unless ( object = @cavelevel.point2object( point ) )

    # ­˳ʤȤRogueޥɡ
    if ( object.stairsdown? )
      do_go_down( client, point )
    elsif object.trap_door? && object.found? # Ȥӹࡣ
      do_trap_door( client, object, point )
    elsif object.pit?                        # ܤӹࡣ
      do_fall_pit( client, object, point )
    end

  end

  def client_get_point( client )
    client.get_point
  end
  
  def investigate( client )

    player = client.player
    
    screen = player2screen( player )
    
    loop do
      
      return false unless ( point = client_get_point( client ) )

      if player.blindcount?
	investigate_message( client, player.mesg[ 1870 ] )
	next
      end
	
      if ( monster_id = screen.monsters[ point ] )
	investigate_message( client, player.real_monstername_id( monster_id ) )
      end

      if ( object_id = screen.objects[ point ] )
	investigate_message( client, player.id2objectname( object_id )  )
      end

    end

  end

  def investigate_message( client, str )
    client.investigate_message( str )
  end
  
  def teleport_as_command( client )

    player = client.player
    mesg   = player.mesg

    unless player.enable_teleport?
      message( client, mesg[ 1875 ] )
      return
    end

    # ԤȤޤա
    teleport( client, true )
    
  end
    
end
