module Movemonster

  def move_all_monsters( client )

    player = client.player
    
    # timestopʤɤṳ̈ȯưƤʤ...
    return unless player.monster_can_move?

    # Distancemapϡ
    # 󥹥   @intelligent_map
    # Хѥ       @vampire_map
    # 2ढФ褤
    
    @intelligent_map = Distancemap.new unless @intelligent_map
    @vampire_map     = Distancemap.new unless @vampire_map

    point = @cavelevel.player2point( player )
    
    rows  = ( ( player.aggravate? ) ?  5 :  3  )
    cols  = ( ( player.aggravate? ) ? 10 :  5  )
    depth = ( ( player.aggravate? ) ? 40 : 17  )
        
    # to_move = [ [ point1, monster1 ], [ point2, monster2 ], ..., ]
    to_move = @cavelevel.to_move_monsters( point, rows, cols )

    # ư٤󥹥˸󥹥
    # Υޥåפ򹹿롣
    
    p, monster = to_move.find { | _p, mon | mon.intelligent? && !mon.vampire? }
    @intelligent_map.calculate( @cavelevel, monster, point, rows, cols, depth ) if monster

    # ư٤󥹥ˡХѥޤޤƤ...

    p, vampire = to_move.find { | _p, mon | mon.vampire? }
    @vampire_map.calculate( @cavelevel, vampire, point, rows, cols, depth ) if vampire
    
    to_move.each do | m_point, monster |
      
      next if monster.asleep? && ( !player.aggravate? && player.stealth? )
      move_monster( client, monster, m_point, @intelligent_map, @vampire_map )

    end

  end
  
  # ޤưǤtrue
  
  def move_scare_monster( client, monster, point )

    return false unless client.player.scaremonst?
    
    # ˼Ϥ֡
    target_point = @cavelevel.random_point_near( point )

    # ư褦ʤ...
    if @cavelevel.monster_movable?( monster, target_point )
      do_move_monster( client, monster, point, target_point )
      return true
    end
    
    false # ưԡ

  end

  def where_to_move( monster, point, map = nil )

    min_length = nil
    min_point  = nil
    
    shuffle_dirs.each do | dir |

      check_point = next_point( point, dir )
      
      if map
	value = map.distance( check_point )
      else
	value  = @cavelevel.nearest_player_length( check_point )
      end

      next unless value
      next unless @cavelevel.monster_movable?( monster, check_point )
      next if min_length && ( min_length <= value ) 

      min_length = value
      min_point  = check_point
      
    end

    min_point
    
  end

  def intelligent_move( client, monster, point, map )

    return false unless map
    return false unless monster.intelligent?
    return false unless ( distance = map.distance( point ) ) # ΥԳꡣ
    return false unless ( to =  where_to_move( monster, point, map ) )

    do_move_monster( client, monster, point, to )

    true # ޤưǤ

  end

  def monster_annihilated?( client, monster, to )

    player = client.player
    
    # sphere̵OK
    return false unless ( sphere = @cavelevel.point2sphere( to ) )

    # ̤Υ󥹥ˤsphere̵
    if monster.move_dispell_sphere?
      message( client, player.mesg[ 850 ], player.real_monstername( monster ) )
      remove_sphere( client, sphere, to ) # sphereǡ
      return false # OK
    end

    # sphereˤäơmonsterǡ
    @cavelevel.monster_killed( monster, to )
    client_movemonst( client, monster, to, nil )
    true
    
  end

  def monster_fall?( client, monster, to )

    return false unless ( object = @cavelevel.point2object( to ) )
    return false if !object.pit? && !( object.trapdoor? ) 
    
    # Ȥȡ٤ȽФƤޤ
    @cavelevel.monster_killed( monster, to )
    client_movemonst( client, monster, to, nil )
    true
    
  end

  def steal_item_from_cave( client, monster, to )
    
    return unless monster.leprechaun?
    return if !( object = @cavelevel.point2object( to ) ) || !object.leprechaun_love?

    lose_object( client, object, to )

  end

  def regenerate_monster( client, monster, to )

    return unless monster.troll?
    return unless client.player.regenerate_monster?
    
    monster.regenerate

  end
  
  def do_move_monster( client, monster, from, to )

    monster.wakeup

    @cavelevel.move_monster( monster, from, to )
    client_movemonst( client, monster, from, to )
    
    # sphere of annihilationΥåsphreˤämonster̤true
    return if monster_annihilated?( client, monster, to )

    # ȤåȤƤޤtrue
    return if monster_fall?( client, monster, to )

    steal_item_from_cave( client, monster, to )

    regenerate_monster( client, monster, to )

    trap_monster( client, monster, to )
    		  
  end

  def teleport_monster( client, monster, from )

    return unless ( to = @cavelevel.teleport_monster( monster ) )
    update_point( client, from )
    update_point( client, to )
    
  end
  
  def trap_monster( client, monster, to )

    player = client.player
    mesg   = player.mesg
    
    return unless ( trap = @cavelevel.point2object( to ) )
   
    # trapоݤˤʤΤϡ
    # traparrow, dartrap, teleporter3ĤΤߡ
    # Ƥ櫤ˤĤƤϽ򤷤ʤ
    
    if trap.trap_arrow? && trap.found?
      monster.traparrow( @level )
      monster_killed( client, monster, to ) if monster.killed?
    elsif trap.trap_dart? && trap.found?
      monster.dartrap
      monster_killed( client, monster, to ) if monster.killed?
    elsif trap.trap_teleporter? && trap.found?
      teleport_monster( client, monster, to )
    else
      return
    end
        
    return unless player2screen( player ).know?( *to )

    if trap.trap_arrow?
      message( client, ( monster.killed? ? mesg[ 852 ] : mesg[ 851 ] ),
	      player.real_monstername( monster ) )
    elsif trap.trap_dart?
      message( client, ( monster.killed? ? mesg[ 854 ] : mesg[ 853 ] ),
	      player.real_monstername( monster ) )
    elsif trap.trap_teleporter?
      message( client, mesg[ 855 ], player.real_monstername( monster ) )
    end
        
  end
 
  # frommonsterθ߰֡
  # fromܤƤץ쥤䡼Ŭӹ⡣
  # Ǥtrue

  def monster_attack( client, monster, from )

    mesg = client.player.mesg
    
    # ܤץ쥤䡼ϵʤǰ
    if ( targets = @cavelevel.players_near_with_point( from ) ).empty?
      return false
    end
      
    # RubyLarnϰѤΥʤΤǡ
    # target == client.player
    # target_client == client

    to, target = targets[ 0 ]
    # target_client = player2client( player )

    # targetˤϡ̵
    return true if monster.spiritual? && target.anti_spritual?
    return true if monster.undead? && target.anti_undead?

    # ԲĻ°ˤꡢ
    if target.escape_invisibility?
      message( client, mesg[ 860 ], target.monstername( monster ) )
      return true
    end

    # ̥λˤꡢ
    if target.escape_charmcount?( monster )
      message( client, mesg[ 861 ], target.monstername( monster ) )
      return true
    end
    
    damage = monster.damage
    bias   = $HARDGAME + 1 
    done   = false
    
    # ޤü칶⤬衣
    
    if monster.special_attack? && !( target.escape_special_attack?( damage + bias ) )
      return true if special_attack( client, monster, from, to )
      bias -= 2
      done  = true
    end

    if !target.escape_attack?( damage + bias )
      message( client, mesg[ 862 ], target.monstername( monster ) )
      death_monster_attack( client, monster, damage )
      done = true
    end

    unless done # ü칶Ԥ鷺̾ﹶ⼺Ԥλ...
      message( client, mesg[ 863 ], target.monstername( monster ) )
    end

    true

  end

  def monster_eat_armor( client, monster, from, to )

    player = client.player
    mesg   = player.mesg

    if player.shield_eaten
      message( client, mesg[ 873 ], player.monstername( monster ) )
    elsif player.armor_eaten
      message( client, mesg[ 872 ], player.monstername( monster ) )
    elsif ( armor = player.wear ) && armor.leather? # 鳻
      message( client, mesg[ 870 ], player.monstername( monster ) )
    elsif armor && armor.ssplate? # ƥ쥹γ
      message( client, mesg[ 871 ], player.monstername( monster ) )
    end

    false
    
  end

  def monster_light_fire( client, monster, from, to, fire = false )

    player = client.player
    mesg   = player.mesg

    if player.fireresistance? # ʤ̵
      message( client, mesg[ 875 ], player.monster_call( monster ) )
    else
      message( client, mesg[ 874 ], player.monster_call( monster ) )
      death_monster_attack( client, monster,
			   ( fire ? monster.fire : monster.light_fire ) )
    end

    false

  end
  
  def monster_fire( client, monster, from, to )
    monster_light_fire( client, monster, from, to, true )
  end

  def monster_sing( client, monster, from, to )

    player = client.player
    mesg   = player.mesg

    strength = player.strength
    player.strength_down

    if strength != player.strength
      message( client, mesg[ 876 ], player.monster_call( monster ) )
    else
      message( client, mesg[ 877 ], player.monster_call( monster ) )
    end
    
    false

  end

  def monster_cold_breath( client, monster, from, to )
    special_attack_routine( client, monster, from, to,
			   client.player.mesg[ 878 ], monster.cold_breath )
  end

  def monster_drain_level( client, monster, from, to )
    
    player = client.player
    mesg   = player.mesg
    
    message( client, mesg[ 879 ], player.monster_call( monster ) )

    do_drain_level( client )
    
    false
        
  end

  def do_drain_level( client )

    player = client.player
    
    prelevel = player.level
    player.drain_level

    if player.level != prelevel # ٥뤬äʤ...
      message( client, player.mesg[ 435 ], player.level )
    end
    
  end

  def monster_water_gusher( client, monster, from, to )
    special_attack_routine( client, monster, from, to,
			   client.player.mesg[ 880 ], monster.water_gusher )
  end
  
  def special_attack_routine( client, monster, from, to, mesg, damage )

    player = client.player

    message( client, mesg, player.monster_call( monster ) )
    death_monster_attack( client, monster, damage )

    false

  end

  def monster_disappear( client, monster, from )
    @cavelevel.monster_disappear( monster, from )
    client_movemonst( client, monster, from, nil )
  end
  
  def monster_steal_gold( client, monster, from, to )

    player = client.player
    mesg   = player.mesg

    return false if player.notheft?

    if player.gold > 0
      message( client, mesg[ 881 ], player.monster_call( monster ) )
      player.steal_gold
    else
      message( client, mesg[ 882 ], player.monster_call( monster ) )
    end

    monster_disappear( client, monster, from )
    return true
    
  end

  def monster_disenchant( client, monster, from, to )

    player = client.player
    mesg   = player.mesg

    unless ( obj = player.disenchantable_item ) # Ŭʥƥʤ
      message( client, mesg[ 884 ], player.monster_call( monster ) )
      return false
    end
          
    obj.disenchant
    
    message( client, mesg[ 883 ], player.monster_call( monster ) )
    item( client, obj )
        
    false

  end

  def monster_barbed_tail( client, monster, from, to )
    special_attack_routine( client, monster, from, to,
			   client.player.mesg[ 885 ], monster.barbed_tail )
  end
  
  def monster_confusion( client, monster, from, to )

    player = client.player

    message( client, player.mesg[ 886 ], player.monster_call( monster ) )
    player.get_confuse( 10 + rnd( 10 ) )

    false

  end

  def monster_psionics( client, monster, from, to )
    special_attack_routine( client, monster, from, to,
			   client.player.mesg[ 885 ], monster.barbed_tail )
  end

  def monster_steal_objects( client, monster, from, to )

    player = client.player
    mesg   = player.mesg

    return false if player.notheft?
    
    if player.empty_handed?
      message( client, mesg[ 888 ], player.monster_call( monster ) )
      return false
    end

    if !( obj = player.item_for_steal )
      message( client, mesg[ 890 ], player.monster_call( monster ) )
    else
      message( client, mesg[ 889 ], player.monster_call( monster ) )
      item( client, obj )
      player.lose_item( obj )
    end

    monster_disappear( client, monster, from )
    true

  end

  
  def monster_bite( client, monster, from, to )

     special_attack_routine( client, monster, from, to,
			   client.player.mesg[ 891 ], monster.bite )

  end

  def monster_hard_bite( client, monster, from, to )

     special_attack_routine( client, monster, from, to,
			    client.player.mesg[ 891 ], monster.hard_bite )

  end

  CAST_SPELLS = [
    :monster_eat_armor,
    :monster_light_fire,
    :monster_fire,
    :monster_cold_breath,
    :monster_drain_level,
    :monster_steal_gold,
    :monster_disenchant,
    :monster_confusion,
    :monster_psionics,
    :monster_steal_objects,
  ]


  # ¾Υ󥹥ü칶򿿻餷
  def monster_cast_spells( client, monster, from, to )
    send( CAST_SPELLS[ rand( CAST_SPELLS.size ) ], client, monster, from, to )
  end
  
  # monsterclient.playerü칶⡣
  # from: 󥹥Τꡣ
  # to: playerεꡣ
  
  def special_attack( client, monster, from, to )
    
    player = client.player
    mesg   = player.mesg

    return false if player.cancellation?
        
    if monster.eat_armor?
      monster_eat_armor( client, monster, from, to )
    elsif monster.light_fire?
      monster_light_fire( client, monster, from, to )
    elsif monster.fire?
      monster_fire( client, monster, from, to )
    elsif monster.sing?
      monster_sing( client, monster, from, to )
    elsif monster.cold_breath?
      monster_cold_breath( client, monster, from, to )
    elsif monster.drain_level?
      monster_drain_level( client, monster, from, to )
    elsif monster.water_gusher?
      monster_water_gusher( client, monster, from, to )
    elsif monster.steal_gold?
      monster_steal_gold( client, monster, from, to )
    elsif monster.disenchant?
      monster_disenchant( client, monster, from, to )
    elsif monster.barbed_tail?
      monster_barbed_tail( client, monster, from, to )
    elsif monster.confusion?
      monster_confusion( client, monster, from, to )
    elsif monster.cast_spells?
      monster_cast_spells( client, monster, from, to )
    elsif monster.psionics?
      monster_psionics( client, monster, from, to )
    elsif monster.steal_objects?
      monster_steal_objects( client, monster, from, to )
    elsif monster.bite?
      monster_bite( client, monster, from, to )
    elsif monster.hard_bite?
      monster_hard_bite( client, monster, from, to )
    end
  
  end

  # pointmonsterθ߰֡
  def move_monster( client, monster, point, i_map, v_map )

    # ư٤󥹥ϡ21ιưˤʤޤ
    return if ( player = client.player ).monster_must_stop?( monster )

    # scaremonstκˤϡǤưޤ
    return if move_scare_monster( client, monster, point )

    # ܤƤץ쥤䡼˹⡣
    return if monster_attack( client, monster, point )
    
    # 󥹥ξ硢ΥĤ褦ưޤ
    return if intelligent_move( client, monster, point,
				  ( monster.vampire? ? v_map : i_map ) )

    simple_move( client, monster, point )

  end


  def simple_move( client, monster, from )

    return false unless ( to =  where_to_move( monster, from ) )

    do_move_monster( client, monster, from, to )

  end

end
