module Potion

  def opotion( client, object, point )

    player = client.player
    mesg   = player.mesg

    answer = reach_question( client,
			    sprintf( mesg[ 701 ], player.objectname( object ) ),
			    mesg[ 702 ],
			    { ?d => mesg[ 703 ],
			      ?t => mesg[ 704 ],
			      ?i => mesg[ 705 ], ?\e => mesg[ 705 ] } )

    case answer
    when ?i, ?\e
      return
    when ?d
      quaffpotion( client, object, point )
    when ?t
      take( client, object, point )
    end

  end

  def pocket_quaff( client, point )

    player = client.player
    mesg   = player.mesg
  
    choice = client.select( mesg[ 1550 ], player.list_quaffable,
			   mesg[ 152 .. 154 ], mesg [ 1551 ] )

    return if !( choice.is_a?( Fixnum ) ) || !( choice.between?( ?a, ?z ) ) 

    unless ( potion = player.pocket( choice ) )
      message( client, mesg[ 1552 ], choice )
      return true
    end

    unless potion.potion?
      message( client, mesg[ 1553 ] )
      return true
    end

    do_quaffpotion( client, potion, point )
    player.lose_item( potion )

    true
    
  end

  def quaffpotion( client, object, point )

    do_quaffpotion( client, object, point ) # ࡣ
    lose_object( client, object, point ) # 󥸥⤫õ

  end

  def do_quaffpotion( client, object, point )

    client.player.identify( object ) # ̡

    if object.sleep?
      sleep( client )
    elsif object.healing?     
      potion_healing( client )
    elsif object.raise_level? 
      raise_level( client )
    elsif object.increase_ability?
      increase_ability( client )
    elsif object.wisdom?
      potion_wisdom( client )
    elsif object.strength?
      potion_strength( client )
    elsif object.raise_charisma?
      raise_charisma( client )
    elsif object.dizziness?
      dizziness( client )
    elsif object.learning?
      learning( client )
    elsif object.gold_detection?
      gold_detection( client )
    elsif object.monster_detection?
      monster_detection( client )
    elsif object.forgetfulness?
      forgetfulness( client )
    elsif object.water?
      water( client )
    elsif object.blindness?
      blindness( client )
    elsif object.confusion?
      confusion( client )
    elsif object.heroism?
      heroism( client )
    elsif object.sturdiness?
      sturdiness( client )
    elsif object.giant_strength?
      giant_strength( client )
    elsif object.fire_resistance?
      fire_resistance( client )
    elsif object.treasure_finding?
      treasure_finding( client )
    elsif object.instant_healing?
      instant_healing( client )
    elsif object.cure_dianthroritis?
      cure_dianthroritis( client )
    elsif object.poison?
      poison( client )
    elsif object.see_invisible?
      see_invisible( client, point )
    end

  end
  
  def potion_routine( client, method, mesg )

    message( client, mesg )        if mesg
    client.player.send( method )   if method

  end
  
  def sleep( client )
    potion_routine( client, :get_sleep, client.player.mesg[ 710 ] )
  end

  def potion_healing( client )
    potion_routine( client, :potion_healing, client.player.mesg[ 712 ] )
  end
  
  def raise_level( client )
    potion_routine( client, :potion_raiselevel, client.player.mesg[ 713 ] )
  end
      
  def increase_ability( client )
    potion_routine( client, :increase_ability, client.player.mesg[ 714 ] )
  end

  def potion_wisdom( client )
    potion_routine( client, :potion_wisdom, client.player.mesg[ 715 ] )
  end

  def potion_strength( client )
    potion_routine( client, :potion_strength, client.player.mesg[ 716 ] )
  end

  def raise_charisma( client )
    potion_routine( client, :raise_charisma, client.player.mesg[ 717 ] )
  end

  def dizziness( client )
    potion_routine( client, :dizziness, client.player.mesg[ 718 ] )
  end

  def learning( client )
    potion_routine( client, :learning, client.player.mesg[ 719 ] )
  end

  def gold_detection( client )

    player = client.player

    message( client, player.mesg[ 720 ] )

    player2screen( player ).gold_detection( player, @cavelevel )
    drawscreen( client )
        
  end
  
  def monster_detection( client )

    player = client.player

    player2screen( player ).monster_detection( player, @cavelevel )
    drawscreen( client )

  end

  def forgetfulness( client )

    player = client.player

    message( client, player.mesg[ 721 ] )

    player2screen( player ).forgetfulness( player, @cavelevel )
    drawscreen( client )

  end

  def water( client )
    message( client, client.player.mesg[ 722 ] )
  end

  def blindness( client )
    potion_routine( client, :get_blindcount, client.player.mesg[ 723 ] )
  end

  def confusion( client )
    potion_routine( client, :get_confuse, client.player.mesg[ 724 ] )
  end

  def heroism( client )
    potion_routine( client, :get_hero,   client.player.mesg[ 725 ] )
  end

  def sturdiness( client )
    potion_routine( client, :constitution_up, client.player.mesg[ 726 ] )
  end

  def giant_strength( client )
    potion_routine( client, :get_giantstr, client.player.mesg[ 727 ] )
  end

  def fire_resistance( client )
    potion_routine( client, :get_fireresistance, client.player.mesg[ 728 ] )
  end

  def treasure_finding( client )

    player = client.player
    
    message( client, player.mesg[ 729 ] )
    
    player2screen( player ).treasure_finding( player, @cavelevel )
    drawscreen( client )
    
  end

  def instant_healing( client )
    client.player.instant_healing
  end

  def cure_dianthroritis( client )
    message( client, client.player.mesg[ 730 ] )
  end

  def poison( client )
    potion_routine( client, :get_halfdam, client.player.mesg[ 731 ] )
  end

  def see_invisible( client, point )
    potion_routine( client, :get_seeinvisible, client.player.mesg[ 732 ] )
    showcell( client, point )
  end
  
end
