module Store


  def ostore( client, store, point )

    if store.school?
      store_school( client, store, point )
    elsif store.lrs?
      store_lrs( client, store, point )
    elsif store.tradepost?
      store_tradepost( client, store, point )
    elsif store.bank? || store.bank2?
      store_bank( client, store, point )
    elsif store.home?
      store_home( client )
    elsif store.dndstore?
      store_dndstore( client, store, point )
    end
    
  end

  def store_school( client, store, point )

    player = client.player
    mesg   = player.mesg

    return if @cavelevel.nearbymonst?( player )

    answer = reach_question( client, mesg[ 921 ], mesg[ 922 ],
			    { ?g => mesg[ 923 ],
			      ?i => mesg[ 924 ], ?\e => mesg[ 924 ] } )
    
    case answer
    when ?i, ?\e
      return
    when ?g
      school( client, store )
    end

  end

  def school_routine( client, mesg, method, num )

    player = client.player

    if mesg.is_a? String
      client_school_message( client, mesg )
    elsif mesg.is_a? Array
      mesg.each { | str | client_school_message( client, str ) } 
    end
    
    player.send( method ) if method

    school_refresh( client, num )
    
    print_status( client )
    
  end
  
  def fighters_training_I( client )
    school_routine( client, client.player.mesg[ 944 ], :fighters_training_I,
		   10 )
  end
  
  def fighters_training_II( client )
    school_routine( client, client.player.mesg[ 946 ], :fighters_training_II,
		   15 )
  end


  def introduction_to_wizardry( client )
    school_routine( client, client.player.mesg[ 947 ],
		   :introduction_to_wizardry, 10 )
  end

  def applied_wizardry( client )
    school_routine( client, client.player.mesg[ 949 ], :applied_wizardry, 20)
  end

  def behavioral_psychology( client )
    school_routine( client, client.player.mesg[ 950 ],
		   :behavioral_psychology, 10 )
  end

  def faith_for_today( client )
    school_routine( client, client.player.mesg[ 951 ],
		   :faith_for_today, 10 )
  end

  def contemporary_dance( client )
    school_routine( client, client.player.mesg[ 952 ],
		   :contemporary_dance, 10 )
  end

  def history_of_larn( client )
    school_routine( client, client.player.mesg[ 953 .. 954 ],
		   :history_of_larn, 5 )
  end

  def client_school_message( client, format, *parameter )
    client.school_message( sprintf( format, *parameter ) )
  end

  def client_school_course( client, store )

    player = client.player
    mesg   = player.mesg
    
    client.school_course( mesg[ 928 ], player.course( store ),
			 mesg[ 939 .. 943 ] )

  end

  def client_school_money( client )

    player = client.player
    client.school_money( sprintf( player.mesg[ 938 ], player.gold ) )
    
  end

  def client_school_exit( client ) ; client.school_exit ; end

  def client_school( client )
    mesg = client.player.mesg
    client.school( mesg[ 925 .. 927 ],  mesg[ 937 ] )
  end
  
  
  def school( client, store )

    player = client.player
    mesg   = player.mesg

    client_school( client )

    loop do

      # ȰɽơȤ򤵤롣
      
   
      client_school_money( client )
      course = client_school_course( client, store )
    
      if course == ?\e # ESCȴ롣
	client_school_exit( client )
	return
      end
      
      if store.finished?( course ) # ˼ֺѡ
	client_school_message( client, mesg[ 955 ] )
	next
      end

      if player.gold < 250 # 硣
	client_school_message( client, mesg[ 956 ] )
	next
      end

      # Fighters Training IIϡޤI֤Ƥ顣
      if ( course == ?b ) && !( store.finished?( ?a ) )
      	client_school_message( client, mesg[ 945 ] )
	next
      end

      # Applied WizardryϡIntroductionѤޤƤ顣
      if ( course == ?d ) && !( store.finished?( ?c ) )
	client_school_message( client, mesg[ 948 ] )
	next
      end
      
      player.lose_gold( 250 )
      store.finished( course )
      
      case course
      when ?a
	fighters_training_I( client )
      when ?b
	fighters_training_II( client )
      when ?c
	introduction_to_wizardry( client )
      when ?d
	applied_wizardry( client )
      when ?e
	behavioral_psychology( client )
      when ?f
	faith_for_today( client )
      when ?g
	contemporary_dance( client )
      when ?h
	history_of_larn( client )
      end
      
    end

  end # def


  def school_refresh( client, n_modulo )
    client.player.school_refresh( n_modulo )
  end

  def store_lrs( client, store, point )

    player = client.player
    mesg   = player.mesg

    return if @cavelevel.nearbymonst?( player )

    answer = reach_question( client, mesg[ 961 ], mesg[ 962 ],
			    { ?g => mesg[ 963 ],
			      ?i => mesg[ 964 ], ?\e => mesg[ 964 ] } )
    
    lrs( client ) if answer == ?g

  end

  def client_lrs( client )
    client.lrs( client.player.mesg[ 965 .. 967 ] )
  end

  def client_lrs_tax( client )

    player = client.player
    
    tax    = player.tax
    format = player.mesg[ ( ( tax > 0 ) ? 968 : 969 ) ] 

    # 968 "You presently owe %d gp in taxes.  "
    # 969 "You do not owe us any taxes.           "
    
    client.lrs_tax( sprintf( format, tax ) )

  end

  def client_lrs_money( client )

    player = client.player

    gold   = player.gold
    format = player.mesg[ ( ( gold > 0 ) ? 970 : 971 ) ]

    # 970 "You have %6d gp.    "
    # 971 "You have no gold pieces.  "
    
    client.lrs_money( sprintf( format, gold ) )
    
  end

  def client_lrs_exit( client ) ; client.lrs_exit ; end

  def client_lrs_command( client )

    mesg = client.player.mesg

    client.lrs_command( mesg[ 972 .. 979 ],
		       { ?p => mesg[ 980 ], ?\e => mesg[ 981 ] } )

  end

  def client_lrs_message( client, format, *parameter )
    client.lrs_message( sprintf( format, *parameter ) )
  end
  
  def client_lrs_pay_taxes( client )
    client.lrs_pay_taxes( client.player.mesg[ 982 ] )
  end

  
  
  def lrs( client )

    player = client.player
    mesg   = player.mesg

    client_lrs( client )
  
    loop do

      # ǶλĤȡɽ
      client_lrs_tax( client )
      client_lrs_money( client )

      case client_lrs_command( client )
      when ?\e
      	client_lrs_exit( client )
	return
      when ?\p
	pay_taxes( client )
      end
      
    end

  end

  def pay_taxes( client )

    player = client.player
    mesg   = player.mesg

    if ( amount = client_lrs_pay_taxes( client ) ) < 0
      client_lrs_message( client, mesg[ 983 ] )
    elsif amount > player.gold
      client_lrs_message( client, mesg[ 984 ] )
    else
      before_payment = player.tax
      player.pay_taxes( amount )
      @database.pay( client.name, before_payment - player.tax )
    end

  end
  

  def store_tradepost( client, store, point )

    player = client.player
    mesg   = player.mesg

    return if @cavelevel.nearbymonst?( player )

    answer = reach_question( client, mesg[ 991 ], mesg[ 992 ],
			    { ?g => mesg[ 993 ],
			      ?i => mesg[ 994 ], ?\e => mesg[ 994 ] } )
    
    tradepost( client ) if answer == ?g

  end

  def tradepost_sell( client, index )

    player = client.player
    mesg   = player.mesg

    if !( obj = player.pocket( index ) ) # ʪ⤽̵
      client_tradepost_message( client, mesg[ 1012 ], index )
      return
    elsif !( player.identified?( obj ) ) # ʪ̡̤
      client_tradepost_message( client, mesg[ 1011 ] )
      return
    elsif !( price = obj.price_for_tradepost ) # 㤤ݡ
      client_tradepost_message( client, mesg[ 1016 ] )
      return
    end

    # ʪɽ
    client_tradepost_item( client, obj )

    # ʤθġ
    answer = client_tradepost_sell( client, index, price )

    # ķ
    return if ( answer != ?y ) && ( answer != ?Y )

    # Ω
    player.lose_item( obj )
    player.get_gold( price )
    
  end

  def client_tradepost( client, mesg )
    client.tradepost( mesg )
  end

  def client_tradepost_question( client, mesg )
    client.tradepost_question( mesg )
  end

  def client_tradepost_exit( client )
    client.tradepost_exit
  end

  def client_tradepost_item( client, obj )
    client.tradepost_item( client.player.item( obj ) )
  end

  def client_tradepost_message( client, format, *parameter )
    client.tradepost_message( sprintf( format, *parameter ) )
  end

  def client_dndstore_message( client, format, *para )
    client.dndstore_message( sprintf( format, *para ) )
  end
  
  def client_tradepost_sell( client, index, price )

    player = client.player
    mesg   = player.mesg

    client.tradepost_sell( sprintf( mesg[ 1013 ], index, price ),
			  { ?y => mesg[ 1014 ], ?Y => mesg[ 1014 ],
			    ?n => mesg[ 1015 ], ?N => mesg[ 1015 ],
			    ?\e => mesg[ 1015 ] } )

  end

  def client_tradepost_all_item( client )
    
    player = client.player
    mesg   = player.mesg
    
    client.tradepost_all_item( player.all_item, mesg[ 151 ],
			      player.mobuls_elapsed,
			      player.mobuls_left, mesg[ 152 .. 154 ] )

    
  end
  
  def tradepost( client )

    player = client.player
    mesg   = player.mesg

    client_tradepost( client, mesg[ 995 .. 1001 ] )

    loop do
      
      char = client_tradepost_question( client, mesg[ 1005 .. 1010 ] )
      char = client_tradepost_all_item( client ) if char == ?* 

      next unless char
      
      case char
      when ( ?a .. ?z )
	tradepost_sell( client, char )
      when ?\e
	client_tradepost_exit( client )
	return
      end

    end

  end

  def store_dndstore( client, store, point )

    player = client.player
    mesg   = player.mesg 

    return if @cavelevel.nearbymonst?( player )

    answer = reach_question( client, mesg[ 1021 ], mesg[ 1022 ],
			    { ?g => mesg[ 1023 ],
			      ?i => mesg[ 1024 ], ?\e => mesg[ 1024 ] } )
    
    dndstore( client, store ) if answer == ?g 

  end

  def client_dndstore( client )
    client.dndstore( client.player.mesg[ 1025 .. 1028 ] )
  end

  def client_dndstore_tax( client )

    player = client.player
    mesg   = player.mesg

    tax_message = mesg[ 1320 .. 1322 ].collect do | format |
      sprintf( format, player.tax )
    end
    
    client.dndstore_tax( tax_message, mesg[ 1323 .. 1325 ] )

  end

  def client_dndstore_exit( client )
    client.dndstore_exit
  end

  def client_dndstore_money( client )

    player = client.player
    client.dndstore_money( sprintf( player.mesg[ 1158 ], player.gold ) ) 
    
  end

  def client_dndstore_choose( client, list, mesg )
    client.dndstore_choose( list, mesg )
  end
  
  def dndstore( client, store )

    player = client.player
    mesg   = player.mesg

    client_dndstore( client )

    if player.tax > 0
      client_dndstore_tax( client )
      client_dndstore_exit( client )
      return
    end
    
    page = 0
    
    loop do

      # ʪȽɽơФ롣
      client_dndstore_money( client )
      list = player.dndstore_list( store, page )
      
      index = client_dndstore_choose( client, list, mesg[ 1150 .. 1157 ] )
      
      case index
      when ( ?a .. ?z )
	dndstore_buy( client, store, list, page, index - ?a )
      when ?\e
	client_dndstore_exit( client )
	return
      when ?\s
	page = ( ( page += 1 ) % 4 )
      end
      
    end

  end

  def dndstore_buy( client, store, list, page, num )

    player = client.player
    mesg   = player.mesg

    if !( list[ num ] ) # ܤʤ
      client_dndstore_message( client, mesg[ 1160 ] )
      return
    elsif player.pocketfull? # ʪäѤ
      client_dndstore_message( client, mesg[ 1159 ] )
      return
    elsif player.gold < list[ num ][ 2 ] # ⤬­ꤺ
      client_dndstore_message( client, mesg[ 1161 ] )
      return
    end
      
    # Ω
    player.lose_gold( list[ num ][ 2 ] ) # ʧ
    player.pack_item( obj = store.sold( page, num ) )
    player.identify( obj )
    
    client_dndstore_item( client, obj )

  end

  def client_dndstore_item( client, obj )
    client.dndstore_item( client.player.item( obj ) )
  end

  

  def store_bank( client, store, point )

    player = client.player
    mesg   = player.mesg

    return if @cavelevel.nearbymonst?( player )

    if store.bank?
      answer = reach_question( client, mesg[ 1171 ], mesg[ 1172 ],
			      { ?g => mesg[ 1173 ],
				?i => mesg[ 1174 ], ?\e => mesg[ 1174 ] } )
    else
      
      answer = reach_question( client, mesg[ 1223 ], mesg[ 1224 ],
			      { ?g => mesg[ 1225 ],
				?i => mesg[ 1226 ], ?\e => mesg[ 1226 ] } )
    end
    
    bank( client, store ) if answer == ?g

  end

  def client_bank( client, store )
    client.bank( client.player.mesg[ ( ( store.bank? ) ? 1175 : 1227 ), 1 ] )
  end

  def client_bank_pay_taxes( client )

    player = client.player
    mesg   = player.mesg
    
    client.bank_pay_taxes( mesg[ 1176 .. 1180 ].collect do | string |
			    sprintf( string, player.tax )
			  end,
			  mesg[ 1181 .. 1183 ] )

  end

  def client_bank_exit( client ) ; client.bank_exit ; end

  def client_bank_bankaccount( client )
    player = client.player
    client.bank_bankaccount( sprintf( player.mesg[ 1186 ], player.bankaccount ) )
  end

  def client_bank_gold( client )

    player = client.player
    client.bank_gold( sprintf( player.mesg[ 1187 ], player.gold ) )

  end

  def client_bank_gemlist( client )

    player = client.player
    client.bank_gemlist( player.mesg[ 1185 ], player.gemlist_for_bank )
    
  end

  def client_bank_command( client )

    player = client.player
    mesg   = player.mesg

    # 1206 "deposit"
    # 1207 "withdraw"
    # 1208 "sell a stone"
    # 1209 "escape"

    client.bank_command( { ?d => mesg[ 1206 ], ?w => mesg[ 1207 ],
			  ?s => mesg[ 1208 ], ?\e => mesg[ 1209 ] },
			mesg[ 1190 .. 1205 ] )

  end

  def client_bank_message( client, format, *para )
    client.bank_message( sprintf( format, *para ) )
  end

  def client_bank_get_amount( client, mesg )
    client.bank_get_amount( mesg )
  end
  
  def bank( client, store )

    player = client.player
    
    client_bank( client, store )

    if player.tax > 0 # Ƕ̤ʧδ֤ϡߡ
      client_bank_pay_taxes( client )
      client_bank_exit( client )
      return
    end
    
    loop do

      # Фΰɽ
      client_bank_gemlist( client )
      
      # ȡ¶ۤɽ
      client_bank_bankaccount( client )
      client_bank_gold( client )
      
      case client_bank_command( client )
      when ?d
	bank_deposite( client )
      when ?w
	bank_withdraw( client )
      when ?s
	bank_sellstone( client )
      when ?\e
	client_bank_exit( client )
	return
      end

    end

  end # def bank

  def client_bank_which_stone( client )
    client.bank_which_stone( client.player.mesg[ 1220 ] )
  end
  
  def bank_sellstone( client )

    player = client.player
    mesg   = player.mesg

    case ( alphabet = client_bank_which_stone( client ) )
    when ?\e
      return
    when ( ?a .. ?z )
      if ( gem = player.pocket( alphabet ) ) && ( gem.bank_buy? )
	player.sellstone( gem )
      else
	client_bank_message( client, mesg[ 1221 ], alphabet )
      end
    end

  end
  
  # ¶⡣
  def bank_deposite( client )

    player = client.player
    mesg   = player.mesg

    if ( ( amount = client_bank_get_amount( client, mesg[ 1210 ] ) ) < 0 )
      client_bank_message( client, mesg[ 1211 ] )
    elsif ( amount > player.gold )
      client_bank_message( client, mesg[ 1212 ] )
    else
      player.deposite( amount )
    end

  end
  
  def bank_withdraw( client )

    player = client.player
    mesg   = player.mesg

    if ( ( amount = client_bank_get_amount( client, mesg[ 1215 ] ) ) < 0 )
      client_bank_message( client, mesg[ 1216 ] )
    elsif ( amount > player.bankaccount )
      client_bank_message( client, mesg[ 1217 ] )
    else
      player.withdraw( amount )
    end

  end
  
  # cure dianthrorisisϼäˤ⤫餺֤˹ʤä
  def timeover_with_the_potion( client )
    client.timeover_with_the_potion( client.player.mesg[ 1750 .. 1773 ] )
    death_kill_his_family( client )
  end
  
  # 餺̼Ǥޤä
  def timeover_without_the_potion( client )
    
    to_send = client.player.mesg[ 1780 .. 1803 ].collect { | string |
      sprintf( string, client.name )
    }
    
    client.timeover_without_the_potion( to_send )
    death_kill_his_family( client )
    
  end
  
  # ϥåԡɡ
  def happy_ending( client )
    client.happy_ending( client.player.mesg[ 1810 .. 1833 ] )
    winner( client )
  end

  def home( client )  # ̾εʤ̼¸档

    player = client.player
    mesg   = player.mesg
    
    client.home( mesg[ 1230 .. 1239 ], mesg[ 1240 .. 1244 ], player.mobuls_left )

  end

  def reach_question( client, str1, str2, hash )
    client.reach_question( str1, str2, hash )
  end
  
  def store_home( client )

    return if @cavelevel.nearbymonst?( player = client.player )
    
    mesg = player.mesg

    answer = reach_question( client, mesg[ 305 ], mesg[ 306 ],
			    { ?g  => mesg[ 307 ], ?i => mesg[ 308 ],
			      ?\e => mesg[ 308 ] } )

    return unless ( answer == ?g )
    
    if player.timeover?
      if player.cure_dianthroritis?
	timeover_with_the_potion( client )
      else
	timeover_without_the_potion( client )
      end
    else
      if player.cure_dianthroritis?
	happy_ending( client )
      else
	home( client )
      end
    end
    
  end

end
